/*********************************************
*  液晶表示器制御ライブラリ
*    lcd_init()    ----- 初期化
*    lcd_cmd(cmd)  ----- コマンド出力
*    lcd_data(data) ----- １文字表示出力
*    lcd_str(ptr)  ----- 文字列表示出力
*    lcd_clear()   ----- 全消去
*********************************************/
#include <htc.h>
#include "lcd_lib.h"

/****** 　　　　　　　　　　　　　******/
void lcd_out(unsigned char code, int flag)
{
	if((code & 0x80) != 0)
            DB7 = 1;			//DB7 pin
	else
            DB7 = 0;
	if((code & 0x40) != 0)
            DB6 = 1;			//DB6 pin
	else
            DB6 = 0;
	if((code & 0x20) != 0)
            DB5 = 1;			//DB5 pin
	else
            DB5 = 0;
	if((code & 0x10) != 0)
            DB4 = 1;			//DB4 pin
	else
            DB4 = 0;
	if (flag == 0)
            RS = 1;			//RS pin 
	else
            RS = 0;			//
	_delay(1);              //NOP
	STB = 1;				//E pin STB out
	_delay(2);              //NOP
	STB = 0;				//E pin STB reset
}
/******* 液晶へ1文字表示データ出力 ******/
void lcd_data(unsigned char asci)
{
	lcd_out(asci, 0);               //
	lcd_out(asci<<4, 0);            //
	__delay_us(50);                 //50
}
/****** 文字列表示関数 ******/
void lcd_str(unsigned char* ptr)
{
	while(*ptr != 0)                //
            lcd_data(*ptr++);       //
}
/****** 液晶へ１コマンド出力 ****/
void lcd_cmd(unsigned char cmd)
{
	lcd_out(cmd, 1);                //
	lcd_out(cmd<<4, 1);             //
	/* Clear　 */
	if((cmd == 0x01)||(cmd == 0x02))
            __delay_ms(2);          // 2msec
	else
            __delay_us(50);         // 50
}
/****** 全消去関数 *****/
void lcd_clear(void)
{
	lcd_cmd(0x01);                 //
}
/***** CGRAM *****/
void lcd_cgram(int code, unsigned char* ptr)
{
	int i;

	for(i=0; i<8; i++){         // 
		lcd_cmd(0x40+code*8+i); // 
		lcd_data(*ptr++);       // 
	}
}
/****** 初期化関数 ******/
void lcd_init(void)
{
	__delay_ms(50);
	lcd_out(0x30, 1);			//8bit mode set
	__delay_ms(5);
	lcd_out(0x30, 1);			//8bit mode set
	__delay_ms(1);
	lcd_out(0x30, 1);			//8bit mode set
	__delay_ms(1);
	lcd_out(0x20, 1);			//4bit mode set
	__delay_ms(1);
	lcd_cmd(0x28);			//DL=0 4bit mode
	lcd_cmd(0x08);			//display off C=D=B=0
	lcd_cmd(0x0D);			//display on C=D=1 B=0
	lcd_cmd(0x06);			//entry I/D=1 S=0
	lcd_cmd(0x02);			//cursor home
}